// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINFRM_H__411BDBAC_D035_4095_9781_EBB91D9B5693__INCLUDED_)
#define AFX_MAINFRM_H__411BDBAC_D035_4095_9781_EBB91D9B5693__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#define	WM_ICON_NOTIFY			WM_APP+10
#define CAL_CLASS_NAME			"Desktop Calendar Ver 1.0"
#define WINDOW_NAME				"Calendar"
#define CAL_TIMER				0x01

#define NO_CHANGE				0
#define DAY_CHANGE				1
#define CHANGE_ALL				2

class CMainFrame : public CFrameWnd
{
// Attributes
public:
	NOTIFYICONDATA  m_tnd;			// Structure to bring in a tray Icon	
	HICON			m_hCalIcon;		// Calendar Icon on Tray
	HBITMAP			hMainBitmap;	// Desktop wallpaper bitmap
	CString			m_szFontName;	// Font face name
	INT				m_nFontSize;	// Font Size
	COLORREF		m_crTextColor;	// Text Color
	COLORREF		m_crBackColor;	// BackGround Color
	CTime			m_CurrentTime;	// Current Time
	INT				m_nXPos;		// Starting location X
	INT				m_nYPos;		// Starting location Y
	INT				m_nTransparency; // Transparency

	static const unsigned int	m_nTaskbarCreatedMsg;
// Operations
public:
	HBITMAP LoadImage(CString szFile,long& nWidth,long& nHeight);
	BOOL	SaveBitmap(HDC hDC,HBITMAP hBitmap,CString szPath);
	void	SetCalendar();
	void	ReadRegistry();
	void	WriteRegistry();
	void	SetToolTip(CString szToolTip);
	void	SetIcon(INT nDate);
	int		CheckDate();
public:
	CMainFrame();
protected: 
	virtual LRESULT OnTrayNotification(UINT wParam, LONG lParam);

	DECLARE_DYNAMIC(CMainFrame)
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL DestroyWindow();
	protected:
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMainFrame();

// Generated message map functions
protected:
	LRESULT OnTaskbarCreated(WPARAM wParam, LPARAM lParam);
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnTimeChange();
	afx_msg void OnCalAboutbox();
	afx_msg void OnCalOptions();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__411BDBAC_D035_4095_9781_EBB91D9B5693__INCLUDED_)
