// OptionsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DesktopCalendar.h"
#include "OptionsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COptionsDlg dialog


COptionsDlg::COptionsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COptionsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(COptionsDlg)
	m_uXPos = 0;
	m_uYPos = 0;
	m_bStartUp = FALSE;
	m_nTransparency = 0;
	//}}AFX_DATA_INIT
}


void COptionsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptionsDlg)
	DDX_Text(pDX, IDC_XPOS, m_uXPos);
	DDX_Text(pDX, IDC_YPOS, m_uYPos);
	DDX_Check(pDX, IDC_STARTUP, m_bStartUp);
	DDX_Slider(pDX, IDC_TRANSPARENCY, m_nTransparency);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COptionsDlg, CDialog)
	//{{AFX_MSG_MAP(COptionsDlg)
	ON_BN_CLICKED(IDC_FONT_BTN, OnFontBtn)
	ON_BN_CLICKED(IDC_COLOR_BTN, OnColorBtn)
	ON_WM_PAINT()
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COptionsDlg message handlers
void COptionsDlg::OnFontBtn() 
{
	// TODO: Add your control notification handler code here
	LOGFONT lf;
	memset(&lf, 0, sizeof(LOGFONT));

	CClientDC dc(this);
	lf.lfHeight = -MulDiv(m_nFontSize, dc.GetDeviceCaps(LOGPIXELSY), 72);
	strcpy(lf.lfFaceName,m_szFontName.operator LPCTSTR());
	CFontDialog dlg(&lf);
	if(dlg.DoModal()==IDOK)
	{
		m_szFontName = dlg.GetFaceName();
		m_nFontSize = dlg.GetSize()/10;
		m_crTextColor = dlg.GetColor();
		DrawText();
	}
}

void COptionsDlg::OnColorBtn() 
{
	// TODO: Add your control notification handler code here
	CColorDialog dlg;
	if(dlg.DoModal()==IDOK)
	{
		m_crBackColor = dlg.GetColor();
		DrawText();
	}
}

void COptionsDlg::OnOK() 
{
	// TODO: Add extra validation here
	UpdateData(true);
	CDialog::OnOK();
}

BOOL COptionsDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	CSliderCtrl * pSlider = (CSliderCtrl *)GetDlgItem(IDC_TRANSPARENCY);
	pSlider->SetRange(0,255,true);
	pSlider->SetPos(m_nTransparency);
	UpdateData(false);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void COptionsDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	// TODO: Add your message handler code here
	DrawText();
}

void COptionsDlg::DrawText()
{
	CWnd * pWnd;
	pWnd = GetDlgItem(IDC_SAMPLE_TEXT);
	if(pWnd)
	{
		CDC * pDC = pWnd->GetDC();
		CFont Font;
		Font.CreateFont(m_nFontSize,0, 0, 0, 0, 0,0, 0, DEFAULT_CHARSET,0,0,0,FF_DONTCARE,m_szFontName); 
		pDC->SelectObject(&Font);
		TEXTMETRIC	tmText;
		pDC->GetTextMetrics(&tmText);
		pDC->SetBkMode(TRANSPARENT);
		pDC->SetTextColor(m_crTextColor);
		
		INT m_nCharWidth  = (tmText.tmMaxCharWidth + 2*tmText.tmAveCharWidth);	
		INT m_nCharHeight = tmText.tmHeight + 4;
		
		CRect TextRect;
		CRect ClientRect;
		pWnd->GetClientRect(&ClientRect);
		int nStartX = (ClientRect.Width() -  m_nCharWidth * 6)/2;
		if(nStartX < 0)
			nStartX = 2;
		int nStartY = (ClientRect.Height()-m_nCharHeight)/2;
		if(nStartY < 0)
			nStartY = 2;

		TextRect.left	= nStartX; 
		TextRect.top	= nStartY ;
		TextRect.right	= TextRect.left + m_nCharWidth * 6;
		TextRect.bottom	= TextRect.top + m_nCharHeight;
		CBrush Brush;
		Brush.CreateSolidBrush(m_crBackColor);
		pDC->FillRect(&ClientRect,&Brush);
		pDC->DrawText(_T("Sample"),&TextRect,DT_LEFT|DT_VCENTER|DT_SINGLELINE);
	}
}
